<?php
################################################################################
### This disclaimer must be kept intact in order to use this product.        ###
################################################################################
### Project: jT CarFramework [http://intersofts.com]
### Author: J. Toshio Taniguchi
### Since: 27.04.2011
### Version: 1.0.0
### Copyrights: J. Toshio Taniguchi
### Contact: j.taniguchi@taniguchi-blog.com
################################################################################
### CONTRIBUTORS
### - none
################################################################################
class adminmanagestaticpages {
    private $lang;
    private $form_message;
    private $form_status;
    private $form_style;
    private $list;


    /**
     * Constructor
     * <br>---------------------------------------------------------------------
     */
    public function adminmanagestaticpages($lang=array()){
        $this->lang = $lang;
        
        // load static pages.
        $this->loadStaticPages();
        
        // handle update form.
        if( isset($_POST['updatebtn']) ){
            $this->handleUpdateForm();
        }
    }
    
    /**
     * Private method: handle update form
     * <br>---------------------------------------------------------------------
     * @return void
     */
    private function handleUpdateForm(){
        $desc = trim($_POST['descriptionInput']);
        $key = trim($_POST['keywordInput']);
        $rob = trim($_POST['robotInput']);
        $file = trim($_POST['fname']);
        
        $desc = addslashes($desc);
        $key = addslashes($key);
        $rob = addslashes($rob);
        
        if( empty($desc) ){
            $desc = '';
        }
        if( empty($key) ){
            $key = '';
        }
        if( empty($rob) ){
            $rob = 'noindex,nofollow';
        }
        
        $content  = '<?php' . "\r\n";
        $content .= '$meta_keyword = \''.$key.'\';' . "\r\n";
        $content .= '$meta_description = \''.$desc.'\';' . "\r\n";
        $content .= '$meta_robots = \''.$rob.'\';' . "\r\n";
        
        $path = BASE_ROOT . 'view/page/static_meta/' . $file;
        
        if( !file_exists($path) ){
            return;
        }
        
        if( !$fo = @fopen($path, 'w') ){
            require_once BASE_CLASS . 'class-log.php';
            LogReport::write('Unable to update static page meta file. Read-write permission denied at ' . __FILE__ . ':' . __LINE__);
            $this->form_message = $this->lang['STATIC_PAGE_UPDATE_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        if( !@fwrite($fo, $content) ){
            @fclose($fo);
            require_once BASE_CLASS . 'class-log.php';
            LogReport::write('Unable to update static page meta file. Read-write permission denied at ' . __FILE__ . ':' . __LINE__);
            $this->form_message = $this->lang['STATIC_PAGE_UPDATE_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        @fclose($fo);
        
        $this->form_message = $this->lang['STATIC_PAGE_UPDATE_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        return;
    }
    
    /**
     * Private method: load static pages
     * <br>---------------------------------------------------------------------
     * @return void
     */
    public function loadStaticPages(){
        $path = BASE_ROOT . 'view/page/static_meta/';
        $result = array();
        $error = false;
        
        if( !$dir = @opendir($path) ){
            $error = true;
            $message = 'Unable to open static page directory due an internal error at ' . __FILE__ . ':' . __LINE__;
        }
        else {
            while( false !== ($file = readdir($dir)) ){
                if( $file != '.' && $file != '..' ){
                    $ext = explode('.',$file);
                    $ext = $ext[(count($ext)-1)];
                    $ext = strtolower($ext);
                    
                    if( $ext == 'php' ){
                        array_push($result, $file);
                    }
                }
            }
            
            @closedir($dir);
            
            $this->list = $result;
        }
        
        if( $error ){
            require_once BASE_CLASS . 'class-log.php';
            LogReport::write($message);
            $this->form_message = $this->lang['STATIC_PAGE_LOAD_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
    }
    
    /**
     * Public method: get static pages list.
     * @return array
     */
    public function getList(){
        return $this->list;
    }
    
    /**
     * Public method: get form status
     * <br>---------------------------------------------------------------------
     * @return bool.
     */
    public function getFormStatus()
    {
        return $this->form_status;
    }

    /**
     * Public method: get form message 
     * <br>---------------------------------------------------------------------
     * @return string.
     */
    public function getFormMessage()
    {
        return $this->form_message;
    }

    /**
     * Public method: get form style
     * <br>---------------------------------------------------------------------
     * @return string.
     */
    public function getFormStyle()
    {
        return $this->form_style;
    }
}